#include "YDInput8.h"

#define RELEASE(x)	{ if(x) { x->Release(); x=NULL; } }
#define FREE(x)		{ if(x) { free(x); x=NULL; } }

CYDInput8::CYDInput8()
{
	m_hInst			= NULL;
	m_hWnd			= NULL;
	m_lpDI			= NULL;
	m_lpKeyboard	= NULL;
	m_iJoy			= 0;
	m_mJoy			= NULL;
}

CYDInput8::~CYDInput8()
{
	Delete();
}

// WCXeBbNpR[obN
BOOL CALLBACK CYDInput8::EnumJoyDeviceProc( LPDIDEVICEINSTANCE lpddi, LPVOID pvRef )
{
	CYDInput *p = ( CYDInput8* )pvRef;

	p->m_iJoy++;
	p->m_mJoy = ( LPCDIJOYSTICK )realloc( p->m_mJoy, sizeof( CDIJOYSTICK )*p->m_iJoy );
	ZeroMemory( &p->m_mJoy[p->m_iJoy - 1], sizeof( CDIJOYSTICK ) );
	wcscpy( p->m_mJoy[p->m_iJoy - 1].mInstName, lpddi->tszInstanceName );
	wcscpy( p->m_mJoy[p->m_iJoy - 1].mProdName, lpddi->tszProductName );


	HRESULT ret = p->m_lpDI->CreateDevice( lpddi->guidInstance, &p->m_mJoy[p->m_iJoy - 1].lpJoyDev, NULL );
	if( FAILED(ret) ) {
		return DIENUM_CONTINUE;
	}
	
	ret = p->m_mJoy[p->m_iJoy-1].lpJoyDev->SetDataFormat( &c_dfDIJoystick2 );
	if( FAILED( ret ) ){
		return DIENUM_CONTINUE;
	}

	DIPROPRANGE diprg;
	diprg.diph.dwSize = sizeof( diprg );
	diprg.diph.dwHeaderSize = sizeof( diprg.diph );
	diprg.diph.dwHow = DIPH_BYOFFSET;
	diprg.lMax =  ANALOG_DEPTH;
	diprg.lMin = -ANALOG_DEPTH;
	diprg.diph.dwObj = DIJOFS_X;
	p->m_mJoy[p->m_iJoy - 1].lpJoyDev->SetProperty( DIPROP_RANGE, &diprg.diph );
	diprg.diph.dwObj = DIJOFS_Y;
	p->m_mJoy[p->m_iJoy - 1].lpJoyDev->SetProperty( DIPROP_RANGE, &diprg.diph );
	diprg.diph.dwObj = DIJOFS_Z;
	p->m_mJoy[p->m_iJoy - 1].lpJoyDev->SetProperty( DIPROP_RANGE,&diprg.diph );
	diprg.diph.dwObj = DIJOFS_RX;
	p->m_mJoy[p->m_iJoy - 1].lpJoyDev->SetProperty( DIPROP_RANGE,&diprg.diph );
	diprg.diph.dwObj = DIJOFS_RY;
	p->m_mJoy[p->m_iJoy - 1].lpJoyDev->SetProperty( DIPROP_RANGE,&diprg.diph );
	diprg.diph.dwObj = DIJOFS_RZ;
	p->m_mJoy[p->m_iJoy - 1].lpJoyDev->SetProperty( DIPROP_RANGE,&diprg.diph );


	return DIENUM_CONTINUE;
}

// IuWFNg
BOOL CYDInput8::Create( HWND hWnd, HINSTANCE hInst )
{
	m_hWnd = hWnd;
	m_hInst = hInst;
	HRESULT ret = DirectInput8Create( m_hInst, DIRECTINPUT_VERSION, IID_IDirectInput8, ( void** )&m_lpDI, NULL );
	if( FAILED( ret ) ){
		return FALSE;
	}
	return TRUE;
}

// J
BOOL CYDInput8::Delete()
{
	int i;
	for( i = 0; i < m_iJoy; i++ ){
		if( m_mJoy[i].lpJoyDev ){
			m_mJoy[i].lpJoyDev->Unacquire();
			m_mJoy[i].lpJoyDev->Release();
			m_mJoy[i].lpJoyDev = NULL;
		}
	}
	FREE( m_mJoy );
	m_iJoy = 0;

	if( m_lpKeyboard )
		m_lpKeyboard->Unacquire();
	RELEASE( m_lpKeyboard );

	RELEASE( m_lpDI );

	return TRUE;
}

// L[{[hIuWFNg
BOOL CYDInput8::CreateKeyboard()
{
	if( !m_lpDI )
		return TRUE;

	HRESULT ret = m_lpDI->CreateDevice( GUID_SysKeyboard, &m_lpKeyboard, NULL );
	if( FAILED( ret ) ){
		return FALSE;
	}
	ret = m_lpKeyboard->SetDataFormat( &c_dfDIKeyboard );
	if( FAILED( ret ) ){
		return FALSE;
	}

	ret = m_lpKeyboard->SetCooperativeLevel( m_hWnd, /*DISCL_FOREGROUND | DISCL_NONEXCLUSIVE*/ DISCL_BACKGROUND | DISCL_NOWINKEY );
	if( FAILED( ret ) ){
		return FALSE;
	}

//	m_lpKeyboard->Poll();
//	m_lpKeyboard->Acquire();
	return TRUE;
}

BOOL CYDInput8::StartKeyBoard()
{

	if( m_lpKeyboard->Acquire() != DI_OK )
		return FALSE;
	if( m_lpKeyboard->Poll() != DI_OK )
		return FALSE;
	return TRUE;
}

BOOL CYDInput8::StopKeyBoard()
{
	if( m_lpKeyboard->Unacquire() != DI_OK )
		return FALSE;
	return TRUE;
}

// L[{[h擾
BOOL CYDInput8::GetKeyboard( LPBYTE key )
{
	ZeroMemory( key, 256 );

	if( m_lpKeyboard ){
		HRESULT ret = m_lpKeyboard->GetDeviceState( 256, key );
		if( FAILED( ret ) ){
			m_lpKeyboard->Acquire();
			m_lpKeyboard->Poll();
			ret = m_lpKeyboard->GetDeviceState( 256, key );
			if( ret == DIERR_INPUTLOST )
				return FALSE;
			else if( ret == DIERR_INVALIDPARAM )
				return FALSE;
			else if( ret == DIERR_NOTACQUIRED )
				return FALSE;
			else if( ret == DIERR_NOTINITIALIZED )
				return FALSE;
			else if( ret == E_PENDING )
				return FALSE;
			if( FAILED( ret ) ){
				return FALSE;
			}//ret 0x8007000c ANZX R[hłB HRESULT
		}
	}else{
		BYTE temp[256];
		GetKeyboardState( temp );
		BYTE vk[256] = {
			NULL,VK_ESCAPE,'1','2','3','4','5','6','7','8','9','0',0xbd,NULL,VK_BACK,VK_TAB,
			'Q','W','E','R','T','Y','U','I','O','P',NULL,NULL,VK_RETURN,VK_LCONTROL,'A','S',
			'D','F','G','H','J','K','L',VK_OEM_PLUS,NULL,NULL,VK_LSHIFT,VK_OEM_102,'Z','X','C','V',
			'B','N','M',VK_OEM_COMMA,VK_OEM_PERIOD,VK_OEM_2,VK_RSHIFT,VK_MULTIPLY,VK_LMENU,VK_SPACE,NULL,VK_F1,VK_F2,VK_F3,VK_F4,VK_F5,
			VK_F6,VK_F7,VK_F8,VK_F9,VK_F10,VK_NUMLOCK,VK_SCROLL,VK_NUMPAD7,VK_NUMPAD8,VK_NUMPAD9,VK_SUBTRACT,VK_NUMPAD4,VK_NUMPAD5,VK_NUMPAD6,VK_ADD,VK_NUMPAD1,
			VK_NUMPAD2,VK_NUMPAD3,VK_NUMPAD0,VK_DECIMAL,NULL,NULL,NULL,VK_F11,VK_F12,NULL,NULL,NULL,NULL,NULL,NULL,NULL,
			NULL,NULL,NULL,NULL,VK_F13,VK_F14,VK_F15,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,
			NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,VK_CONVERT,NULL,VK_NONCONVERT,NULL,VK_OEM_5,NULL,NULL,
			NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,
			NULL,NULL,VK_OEM_1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,VK_RETURN,VK_RCONTROL,NULL,NULL,
			NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,
			NULL,NULL,NULL,VK_OEM_COMMA,NULL,VK_DIVIDE,NULL,NULL,VK_RMENU,NULL,NULL,NULL,NULL,NULL,NULL,NULL,
			NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,VK_UP,VK_PRIOR,NULL,VK_LEFT,NULL,VK_RIGHT,NULL,VK_END,
			VK_DOWN,VK_NEXT,VK_INSERT,VK_DELETE,NULL,NULL,NULL,NULL,NULL,NULL,NULL,VK_LWIN,VK_RWIN,NULL,NULL,NULL,
			NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,
			NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,
		};

		// VKDIK
		int i;
		for( i=0;i<256;i++ ) {
			key[i] = temp[vk[i]];
		}
	}
	return TRUE;
}

// SWCXeBbN
BOOL CYDInput8::CreateJoystick()
{
	if( !m_lpDI )
		return FALSE;

	HRESULT ret;
	ret = m_lpDI->EnumDevices( DI8DEVCLASS_GAMECTRL, ( LPDIENUMDEVICESCALLBACK )EnumJoyDeviceProc, this, DIEDFL_ATTACHEDONLY );
	if( FAILED( ret ) )
		return FALSE;

	if( m_iJoy < 1 )
		return FALSE;

	return TRUE;
}

// SWCXeBbNf[^z擾
BOOL CYDInput8::GetJoystick( LPDIJOYSTATE2 js )
{
	if( !m_lpDI )
		return FALSE;
	ZeroMemory( js, sizeof( DIJOYSTATE )*m_iJoy );

	int i;
	for( i = 0; i < m_iJoy; i++ ){
		GetJoystick( &js[i], i );
	}
	return TRUE;
}

// P̃WCXeBbNf[^擾
BOOL CYDInput8::GetJoystick( LPDIJOYSTATE2 js, int id )
{
	if( !m_lpDI )
		return FALSE;

	ZeroMemory( js, sizeof( DIJOYSTATE2 ) );
	if( id < 0 || id > m_iJoy - 1 )
		return FALSE;

	HRESULT ret = m_mJoy[id].lpJoyDev->GetDeviceState( sizeof( DIJOYSTATE2 ), js );
	if( FAILED( ret ) ){
		m_mJoy[id].lpJoyDev->Acquire();
		m_mJoy[id].lpJoyDev->Poll();
		ret = m_mJoy[id].lpJoyDev->GetDeviceState( sizeof( DIJOYSTATE2 ), js );
		if( FAILED( ret ) )
			return FALSE;
	}
	return TRUE;
}

// wID̃CX^XԂ
WCHAR *CYDInput8::GetJoyInstName( int id )
{
	if( id < 0 || id > m_iJoy - 1 ){
		return NULL;
	}
	return m_mJoy[id].mInstName;
}

// wID̐iԂ
WCHAR *CYDInput8::GetJoyProdName( int id )
{
	if( id < 0 || id > m_iJoy - 1 ){
		return NULL;
	}
	return m_mJoy[id].mProdName;
}

BOOL CYDInput8::StartJoystick()
{
	if( !m_mJoy[0].lpJoyDev->Acquire() != DI_OK )
		return FALSE;
	if( m_mJoy[0].lpJoyDev->Poll() != DI_OK )
		return FALSE;
	return TRUE;
}

BOOL CYDInput8::StopJoystick()
{
	if( m_mJoy[0].lpJoyDev->Unacquire() != DI_OK )
		return FALSE;
	return TRUE;
}