#ifdef _MSC_VER
#pragma warning( disable : 4786 )
#endif

#include <cstring>
#include <cstdlib>
#include <algorithm>
#include <locale>
#include <sstream>

#define _WIN32_DCOM
#include <objbase.h>

#include "csaori.h"
#include "csaori_di.h"

//////////DEBUG/////////////////////////
#ifdef _WINDOWS
#ifdef _DEBUG
#include <crtdbg.h>
#define new new( _NORMAL_BLOCK, __FILE__, __LINE__)
#endif
#endif
////////////////////////////////////////

CSAORIBase* CreateInstance(void)
{
	return new CSAORIDi();
}

bool CSAORIDi::load()
{
	m_pDInput = new CYDInput8();
	m_phWnd = NULL;
	m_hInst = NULL;
	m_RegistWndNum = 0;
	m_RegistWndNum = 0;
//	m_pKeyCodeList = NULL;
	m_hThread = NULL;
	m_bThLoopFlag = false;
//	m_ppKeyBuf = NULL;
	m_CheckButtonNum = 32;
	m_AnalogMargin = DEFAULT_ANALOG_MARGIN;

	return true;
}

bool CSAORIDi::unload()
{
	if( m_hThread != NULL ){
		StopDiProc();
	}
	if( m_pDInput != NULL ){
		delete m_pDInput;
		m_pDInput = NULL;
	}
//	if( m_pKeyCodeList != NULL ){
//		delete [] m_pKeyCodeList;
//		m_pKeyCodeList = NULL;
//	}
	if( m_phWnd != NULL ){
		delete [] m_phWnd;
		m_phWnd = NULL;
	}

	return true;
}

void CSAORIDi::exec(const CSAORIInput &in, CSAORIOutput &out)
{
	int error = 0;

	if( in.args.size() == 0 )
		error = 2;
	else{
		// DI擾Jn --------------------------------------------------------
		if( in.args[0] == L"start" ){
//			if( m_pKeyCodeList == NULL || m_hThread != NULL ){
			if( m_hThread != NULL ){
				error = 2;
			}else{
				if( !StartDiProc() )
					error = 1;
			}

		// DI擾~ --------------------------------------------------------
		}else if( in.args[0] == L"stop" ){
			if( !StopDiProc() ){
				error = 2;
			}

		// DirectInputNX쐬 -------------------------------------------------
		}else if( in.args[0] == L"create" ){
			if( m_phWnd != NULL ){
				error = 2;
			}else{
				m_RegistWndNum = in.args.size() - 1;
				m_phWnd = new HWND[ m_RegistWndNum ];
				for( int i = 0; i < m_RegistWndNum; ++i ){
					m_phWnd[i] = ( HWND )StrToHandle( in.args[i + 1].c_str() );
					if( m_phWnd[i] == NULL ){
						delete [] m_phWnd;
						m_phWnd = NULL;
						m_RegistWndNum = 0;
						error = 2;
						break;
					}
				}
				if( error == 0 ){
					// DirectInput
					if( !m_pDInput->Create( m_phWnd[0], g_hModule ) ){
						error = 2;
					}else{
						// L[{[h
//						if( !m_pDInput->CreateKeyboard() ){
//							error = 1;
//						}
						// WCXeBbN
						if( !m_pDInput->CreateJoystick() ){
							error = 1;
						}
					}
				}
			}

		// 擾L[o^ -----------------------------------------------------------
/*		}else if( in.args[0] == L"setkey" ){
			if( m_hThread != NULL ){
				error = 2;
			}else{
				if( m_pKeyCodeList != NULL ){
					delete [] m_pKeyCodeList;
					m_pKeyCodeList = NULL;
					m_RegistKeyNum = 0;
				}
				m_RegistKeyNum = in.args.size() - 1;
				m_pKeyCodeList = new short[ m_RegistKeyNum ];
				for( int i = 0; i < m_RegistKeyNum; ++i ){
					m_pKeyCodeList[i] = ( short )StrToKeycode( in.args[ i+1 ] );
				}
			}
*/
		// RtBO
		}else if( in.args[0] == L"config" ){
			if( in.args[1] == L"margin" ){
				m_AnalogMargin = CheckMargin( _wtoi( in.args[2].c_str() ) );
			}else{
				error = 2;
			}
		}else{
			error = 2;
		}
	}

	if( error == 1 )
		out.result_code = SAORIRESULT_INTERNAL_SERVER_ERROR;
	else if( error == 2 )
		out.result_code = SAORIRESULT_BAD_REQUEST;
	else
		out.result_code = SAORIRESULT_NO_CONTENT;

}

// ----------------------------------------------------------------------------
// 񁨃nhϊ
HANDLE StrToHandle( LPCTSTR sHand )
{
	UINT_PTR uiHand = _ttoi( sHand );
	if( uiHand == 0 )
		return NULL;
	return ( HANDLE )uiHand;
}

// L[R[hϊ
int StrToKeycode( string_t Str )
{
	if( Str == L"ESCAPE" )
		return 0x01;
	else if( Str == L"1" )
		return 0x02;
	else if( Str == L"2" )
		return 0x03;
	else if( Str == L"3" )
		return 0x04;
	else if( Str == L"4" )
		return 0x05;
	else if( Str == L"5" )
		return 0x06;
	else if( Str == L"6" )
		return 0x07;
	else if( Str == L"7" )
		return 0x08;
	else if( Str == L"8" )
		return 0x09;
	else if( Str == L"9" )
		return 0x0A;
	else if( Str == L"0" )
		return 0x0B;
	else if( Str == L"-" || Str == L"MINUS" )
		return 0x0C;
	else if( Str == L"=" || Str == L"EQUALS" )
		return 0x0D;
	else if( Str == L"BACK" )
		return 0x0E;
	else if( Str == L"TAB" )
		return 0x0F;
	else if( Str == L"Q" )
		return 0x10;
	else if( Str == L"W" )
		return 0x11;
	else if( Str == L"E" )
		return 0x12;
	else if( Str == L"R" )
		return 0x13;
	else if( Str == L"T" )
		return 0x14;
	else if( Str == L"Y" )
		return 0x15;
	else if( Str == L"U" )
		return 0x16;
	else if( Str == L"I" )
		return 0x17;
	else if( Str == L"O" )
		return 0x18;
	else if( Str == L"P" )
		return 0x19;
	else if( Str == L"[" || Str == L"LBRACKET" )
		return 0x1A;
	else if( Str == L"]" || Str == L"RBRACKET" )
		return 0x1B;
	else if( Str == L"RETURN" )
		return 0x1C;
	else if( Str == L"LCONTROL" )
		return 0x1D;
	else if( Str == L"A" )
		return 0x1E;
	else if( Str == L"S" )
		return 0x1F;
	else if( Str == L"D" )
		return 0x20;
	else if( Str == L"F" )
		return 0x21;
	else if( Str == L"G" )
		return 0x22;
	else if( Str == L"H" )
		return 0x23;
	else if( Str == L"J" )
		return 0x24;
	else if( Str == L"K" )
		return 0x25;
	else if( Str == L"L" )
		return 0x26;
	else if( Str == L";" || Str == L"SEMICOLON" )
		return 0x27;
	else if( Str == L"'" || Str == L"APOSTROPHE" )
		return 0x28;
	else if( Str == L"`" || Str == L"GRAVE" )
		return 0x29;
	else if( Str == L"LSHIFT" )
		return 0x2A;
	else if( Str == L"BACKSLASH" )
		return 0x2B;
	else if( Str == L"Z" )
		return 0x2C;
	else if( Str == L"X" )
		return 0x2D;
	else if( Str == L"C" )
		return 0x2E;
	else if( Str == L"V" )
		return 0x2F;
	else if( Str == L"B" )
		return 0x30;
	else if( Str == L"N" )
		return 0x31;
	else if( Str == L"M" )
		return 0x32;
	else if( Str == L"," || Str == L"COMMA" )
		return 0x33;
	else if( Str == L"." || Str == L"PERIOD" )
		return 0x34;
	else if( Str == L"/" || Str == L"SLASH" )
		return 0x35;
	else if( Str == L"RSHIFT" )
		return 0x36;
	else if( Str == L"N*" || Str == L"MULTIPLY" )
		return 0x37;
	else if( Str == L"LMENU" || Str == L"LALT" )
		return 0x38;
	else if( Str == L"SPACE" )
		return 0x39;
	else if( Str == L"CAPITAL" || Str == L"CAPSLOCK" )
		return 0x3A;
	else if( Str == L"F1" )
		return 0x3B;
	else if( Str == L"F2" )
		return 0x3C;
	else if( Str == L"F3" )
		return 0x3D;
	else if( Str == L"F4" )
		return 0x3E;
	else if( Str == L"F5" )
		return 0x3F;
	else if( Str == L"F6" )
		return 0x40;
	else if( Str == L"F7" )
		return 0x41;
	else if( Str == L"F8" )
		return 0x42;
	else if( Str == L"F9" )
		return 0x43;
	else if( Str == L"F10" )
		return 0x44;
	else if( Str == L"NUMLOCK" )
		return 0x45;
	else if( Str == L"SCROLL" )
		return 0x46;
	else if( Str == L"N7" || Str == L"NUMPAD7" )
		return 0x47;
	else if( Str == L"N8" || Str == L"NUMPAD8" )
		return 0x48;
	else if( Str == L"N9" || Str == L"NUMPAD9" )
		return 0x49;
	else if( Str == L"N-" || Str == L"SUBTRACT" )
		return 0x4A;
	else if( Str == L"N4" || Str == L"NUMPAD4" )
		return 0x4B;
	else if( Str == L"N5" || Str == L"NUMPAD5" )
		return 0x4C;
	else if( Str == L"N6" || Str == L"NUMPAD6" )
		return 0x4D;
	else if( Str == L"N+" || Str == L"ADD" )
		return 0x4E;
	else if( Str == L"N1" || Str == L"NUMPAD1" )
		return 0x4F;
	else if( Str == L"N2" || Str == L"NUMPAD2" )
		return 0x50;
	else if( Str == L"N3" || Str == L"NUMPAD3" )
		return 0x51;
	else if( Str == L"N0" || Str == L"NUMPAD0" )
		return 0x52;
	else if( Str == L"N." || Str == L"DECIMAL" )
		return 0x53;
	else if( Str == L"OEM102" )
		return 0x56;
	else if( Str == L"F11" )
		return 0x57;
	else if( Str == L"F12" )
		return 0x58;
	else if( Str == L"F13" )
		return 0x64;
	else if( Str == L"F14" )
		return 0x65;
	else if( Str == L"F15" )
		return 0x66;
	else if( Str == L"KANA" )
		return 0x70;
	else if( Str == L"ABNT_C1" )
		return 0x73;
	else if( Str == L"CONVERT" )
		return 0x79;
	else if( Str == L"NOCONVERT" )
		return 0x7B;
	else if( Str == L"YEN" || Str == L"\\" )
		return 0x7D;
	else if( Str == L"ABNT_C2" )
		return 0x7E;
	else if( Str == L"N=" || Str == L"NUMPADEQUALS" )
		return 0x8D;
	else if( Str == L"PREVTRACK" )
		return 0x90;
	else if( Str == L"AT" )
		return 0x91;
	else if( Str == L"COLON" )
		return 0x92;
	else if( Str == L"UNDERLINE" )
		return 0x93;
	else if( Str == L"KANJI" )
		return 0x94;
	else if( Str == L"STOP" )
		return 0x95;
	else if( Str == L"AX" )
		return 0x96;
	else if( Str == L"UNLABELED" )
		return 0x97;
	else if( Str == L"NEXTTRACK" )
		return 0x99;
	else if( Str == L"NUMPADENTER" )
		return 0x9C;
	else if( Str == L"RCONTROL" )
		return 0x9D;
	else if( Str == L"MUTE" )
		return 0xA0;
	else if( Str == L"CALCULATOR" )
		return 0xA1;
	else if( Str == L"PLAYPAUSE" )
		return 0xA2;
	else if( Str == L"MEDIASTOP" )
		return 0xA4;
	else if( Str == L"VOLUMEDOWN" )
		return 0xAE;
	else if( Str == L"VOLUMEUP" )
		return 0xB0;
	else if( Str == L"WEBHOME" )
		return 0xB2;
	else if( Str == L"N," || Str == L"NUMPADCOMMA" )
		return 0xB3;
	else if( Str == L"N/" || Str == L"DIVIDE" )
		return 0xB5;
	else if( Str == L"SYSRQ" )
		return 0xB7;
	else if( Str == L"RMENU" || Str == L"RALT" )
		return 0xB8;
	else if( Str == L"PAUSE" )
		return 0xC5;
	else if( Str == L"HOME" )
		return 0xC7;
	else if( Str == L"UP" )
		return 0xC8;
	else if( Str == L"PRIOR" || Str == L"PGUP" )
		return 0xC9;
	else if( Str == L"LEFT" )
		return 0xCB;
	//
	if( Str == L"RIGHT" )
		return 0xCD;
	else if( Str == L"END" )
		return 0xCF;
	else if( Str == L"DOWN" )
		return 0xD0;
	else if( Str == L"NEXT" || Str == L"PGDN" )
		return 0xD1;
	else if( Str == L"INSERT" )
		return 0xD2;
	else if( Str == L"DELETE" )
		return 0xD3;
	else if( Str == L"LWIN" )
		return 0xDB;
	else if( Str == L"RWIN" )
		return 0xDC;
	else if( Str == L"APPS" )
		return 0xDD;
	else if( Str == L"POWER" )
		return 0xDE;
	else if( Str == L"SLEEP" )
		return 0xDF;
	else if( Str == L"WAKE" )
		return 0xE3;
	else if( Str == L"WEBSEARCH" )
		return 0xE5;
	else if( Str == L"WEBFAVORITES" )
		return 0xE6;
	else if( Str == L"WEBREFRESH" )
		return 0xE7;
	else if( Str == L"WEBSTOP" )
		return 0xE8;
	else if( Str == L"WEBFORWARD" )
		return 0xE9;
	else if( Str == L"WEBBACK" )
		return 0xEA;
	else if( Str == L"MYCOMPUTER" )
		return 0xEB;
	else if( Str == L"MAIL" )
		return 0xEC;
	else if( Str == L"MEDIASELECT" )
		return 0xED;


	return 0x00;
}

// ------------------------------------------------------------------------------------
unsigned __stdcall CSAORIDi::StartThread(void *p)
{
	reinterpret_cast< CSAORIDi* >( p )->diThread();
//	_endthreadex( 0 );
	return 0;
}


// C[vXbh
UINT CSAORIDi::diThread()
{
	CoInitializeEx(NULL,COINIT_APARTMENTTHREADED);

	int iGetFlag = 0;
	int RefCount;
	int marginBuf;
	string_t ValBuf;
	std::string SendVal;
	COPYDATASTRUCT SendData;
	SendData.dwData = 9801;
	DWORD dwRet;

	SetLoopFlag( true );

//	m_ppKeyBuf = new BYTE *[2];
//	for( int i = 0; i < 2; ++i ){
//		m_ppKeyBuf[i] = new BYTE[256];
//		for( int j = 0; j < 256; ++j )
//			m_ppKeyBuf[i][j] = 0x00;
//	}

	ZeroMemory( &m_JoyBuf, sizeof( m_JoyBuf ) );

	m_pDInput->StartJoystick();
	//m_pDInput->StartKeyBoard();

	FrameControl fc(30);
	fc.Start();

	// [v
	while( GetLoopFlag() == true )
	{
//		if( CheckWindowActive() == false ){
//			m_pDInput->StopKeyBoard();
//			m_pDInput->StopJoystick();
//			Sleep(1);
//		}else{
			ValBuf = L"NOTIFY SSTP/1.0\r\nSender: UkaPad\r\nEvent: OnUkaPadState\r\n";
			RefCount = 0;
			m_pDInput->GetJoystick( &m_JoyBuf[ iGetFlag ], 0 );

			// pbh -----------------------------------------------------------------------
			// AiOL[
			marginBuf = m_AnalogMargin;
			ValBuf += L"Reference0: ";
			ValBuf += SAORI_FUNC::intToString( MarginProc( ( int )m_JoyBuf[ iGetFlag ].lX, marginBuf ) );
			ValBuf += L"\r\nReference1: ";
			ValBuf += SAORI_FUNC::intToString( MarginProc( ( int )m_JoyBuf[ iGetFlag ].lY, marginBuf ) );
			ValBuf += L"\r\nReference2: ";
			ValBuf += SAORI_FUNC::intToString( MarginProc( ( int )m_JoyBuf[ iGetFlag ].lZ, marginBuf ) );
			ValBuf += L"\r\nReference3: ";
			ValBuf += SAORI_FUNC::intToString( MarginProc( ( int )m_JoyBuf[ iGetFlag ].lRx, marginBuf ) );
			ValBuf += L"\r\nReference4: ";
			ValBuf += SAORI_FUNC::intToString( MarginProc( ( int )m_JoyBuf[ iGetFlag ].lRy, marginBuf ) );
			ValBuf += L"\r\nReference5: ";
			ValBuf += SAORI_FUNC::intToString( MarginProc( ( int )m_JoyBuf[ iGetFlag ].lRz, marginBuf ) );
			ValBuf += L"\r\n";
			RefCount = 6;

			// {^
			for( int i = 0; i < m_CheckButtonNum; ++i ){
				ValBuf += L"Reference";
				ValBuf += SAORI_FUNC::intToString( RefCount + i );
				ValBuf += L": ";
				ValBuf += SAORI_FUNC::intToString( KeyStateConvert( m_JoyBuf[ iGetFlag ].rgbButtons[i], m_JoyBuf[ ( iGetFlag + 1 ) % 2 ].rgbButtons[i] ) );
				ValBuf += L"\r\n";
			}
			RefCount += m_CheckButtonNum;

			// L[{[h -------------------------------------------------------------------
//			m_pDInput->GetKeyboard( m_ppKeyBuf[ iGetFlag ] );
//			for( int i = 0; i < m_RegistKeyNum; ++i ){
//				ValBuf += L"Reference";
//				ValBuf += SAORI_FUNC::intToString( RefCount + i );
//				ValBuf += L": ";
//				ValBuf += SAORI_FUNC::intToString( KeyStateConvert( m_ppKeyBuf[ iGetFlag ][ m_pKeyCodeList[i] ], m_ppKeyBuf[ ( iGetFlag + 1 ) % 2 ][ m_pKeyCodeList[i] ] ) );
//				ValBuf += L"\r\n";
//			}
			ValBuf += L"Charaset: UTF-8\r\n\r\n";

			SendVal = SAORI_FUNC::UnicodeToMultiByte( ValBuf.c_str(), CP_UTF8, 0 );
			
			/*char *SendStr = new char[ SendVal.size() + 1 ];
			strcpy( SendStr, SendVal.c_str() );
			SendData.cbData = SendVal.size() + 1;
			SendData.lpData = SendStr;*/
			
			if( IsWindow( m_phWnd[0] ) ){
				::SendMessageTimeoutA( m_phWnd[0], WM_COPYDATA, ( WPARAM )m_phWnd[0], ( LPARAM )SendVal.c_str(), SMTO_ABORTIFHUNG, 1000, &dwRet );
			}
			
			/*delete [] SendStr;*/

			iGetFlag = ( iGetFlag + 1 ) % 2;
			
			fc.End();
			fc.Start();
//		}
	}

	//m_pDInput->StopKeyBoard();
	m_pDInput->StopJoystick();

	// ㏈
//	if( m_ppKeyBuf != NULL ){
//		for( int i = 0; i < 2; ++i ){
//			if( m_ppKeyBuf[i] != NULL ){
//				delete [] m_ppKeyBuf[i];
//				m_ppKeyBuf[i] = NULL;
//			}
//		}
//		delete [] m_ppKeyBuf;
//		m_ppKeyBuf = NULL;
//	}

	CoUninitialize();

	return 0;
}

// XbhX^[g -----------------------------------------------------------------
BOOL CSAORIDi::StartDiProc()
{
	unsigned int thread_id;
	m_hThread = ( HANDLE )_beginthreadex( NULL, 0, &CSAORIDi::StartThread, this, 0, &thread_id );
	if( m_hThread == 0 ){
		return FALSE;
	}

	return TRUE;
}

// XbhXgbv
BOOL CSAORIDi::StopDiProc()
{
	if( m_hThread == NULL ){
		return FALSE;
	}
	SetLoopFlag( false );
	WaitForSingleObject( m_hThread, INFINITE );
	CloseHandle( m_hThread );
	m_hThread = NULL;

	return TRUE;
}
// [vtOANZXr -------------------------------------------------------
void CSAORIDi::SetLoopFlag( bool flag )
{
	SAORI_FUNC::CCriticalSectionLock lock(m_loopFlagLock);
	m_bThLoopFlag = flag;
}

bool CSAORIDi::GetLoopFlag()
{
	SAORI_FUNC::CCriticalSectionLock lock(m_loopFlagLock);
	return m_bThLoopFlag != 0;
}
//-------------------------------------------------------------------------------------
// L[R[h
int CSAORIDi::KeyStateConvert( BYTE now, BYTE old )
{
	if( !( now & 0x80 ) && !( old & 0x80 ) )
		return KS_NONE;
	if( ( now & 0x80 ) == 0x80 && !( old & 0x80 ) )
		return KS_DOWN;
	if( ( now & 0x80 ) && ( old & 0x80 ) )
		return KS_PRESS;
	if( !( now & 0x80 ) && ( old & 0x80 ) )
		return KS_UP;

	return -1;
}

//-------------------------------------------------------------------------------------
// EBhEANeBu`FbN
bool CSAORIDi::CheckWindowActive()
{
	BOOL Check;
	GUITHREADINFO gui;
	gui.cbSize = sizeof( GUITHREADINFO );
	DWORD idThread = GetWindowThreadProcessId( m_phWnd[0], NULL );
	if( Check = GetGUIThreadInfo( idThread, &gui ) != NULL ){
		for( int i = 0; i < m_RegistWndNum; ++i ){
			if( m_phWnd[i] == gui.hwndActive )
				return true;
		}
	}
/*
	HWND acw = GetForegroundWindow();
	if( acw == NULL )
		return true;
	for( int i = 0; i < m_RegistWndNum; ++i ){
		if( m_phWnd[i] == acw )
			return true;
	}
*/
	return false;
}

// AiOo[Vѓ̓`FbN
int CSAORIDi::CheckMargin( int margin )
{
	if( margin < 0 )
		return 0;
	else if( margin > 1000 )
		return 1000;
	else
		return margin;
}

// Vѕ␳
int CSAORIDi::MarginProc( int in, int margin )
{
	if( in < -margin || in > margin   )
		return in;
	else
		return 0;
}